## rr 4.1.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 2.8.5)
project(rr C CXX ASM)

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 4)
set(rr_VERSION_MINOR 1)
set(rr_VERSION_PATCH 0)

add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -O0 -g3 -Wall -Werror -Wstrict-prototypes")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -O0 -g3 -Wall -Werror")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")

# Check that a 32-bit cross-compile works. This is needed regardless
# of whether the entire build is being built 32-bit.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
  # try_compile won't accept LINK_FLAGS, so do this manually.
  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
  execute_process(COMMAND ${CMAKE_CXX_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
			RESULT_VARIABLE COMPILER_32BIT_RESULT)
  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation.")
  endif()
endif()

option(force32bit, "Force a 32-bit build, rather than a 64-bit one")
if(force32bit)
  set(rr_64BIT false)
  set(rr_MBITNESS_OPTION -m32)
else()
  if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(rr_64BIT true)
  else()
    set(rr_64BIT false)
  endif()
  set(rr_MBITNESS_OPTION)
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")

find_package(PkgConfig REQUIRED)

# If we're cross-compiling a 32-bit build on a 64-bit host we need
# to ensure we're looking for the right libraries.
# This has been tested on Ubuntu and Fedora.
set(LIBDIR32_CANDIDATES
  /usr/lib/i386-linux-gnu/pkgconfig/
  /usr/lib/pkgconfig/
)
if((NOT rr_64BIT) AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
  foreach(libdir ${LIBDIR32_CANDIDATES})
    if(IS_DIRECTORY ${libdir})
      set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
      break()
     endif()
   endforeach(libdir)
   if (NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
     message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
   endif()
endif()

# Check for required libraries
set(REQUIRED_LIBS
  zlib
)
foreach(required_lib ${REQUIRED_LIBS})
  string(TOUPPER ${required_lib} PKG)
  pkg_check_modules(${PKG} REQUIRED ${required_lib})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
endforeach(required_lib)

# Check for Python >=2.7 but not Python 3.
find_package(PythonInterp 2.7 REQUIRED)
if(PYTHON_VERSION_MAJOR GREATER 2)
  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
endif()

# Check for required Python modules
set(REQUIRED_PYTHON_MODULES
  pexpect
)
foreach(py_module ${REQUIRED_PYTHON_MODULES})
  execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
			"import ${py_module}"
			RESULT_VARIABLE module_status)
  if(module_status)
    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
  endif()
endforeach(py_module)

# Check for gdb
execute_process(COMMAND "gdb" "--version" RESULT_VARIABLE module_status)
if(module_status)
  message(FATAL_ERROR "Couldn't find gdb.")
endif()

set_source_files_properties(src/preload/preload.c PROPERTIES COMPILE_FLAGS -O2)

include_directories("${PROJECT_SOURCE_DIR}/include")
# We need to know where our generated files are.
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

add_library(rrpreload
  src/preload/preload.c
  src/preload/raw_syscall.S
  src/preload/syscall_hook.S
  src/preload/breakpoint_table.S
)

# Ensure that CMake knows about our generated files.
#
# Alphabetical, please.
set(GENERATED_FILES
  AssemblyTemplates.generated
  CheckSyscallNumbers.generated
  SyscallEnumsX64.generated
  SyscallEnumsX86.generated
  SyscallEnumsForTestsX64.generated
  SyscallEnumsForTestsX86.generated
  SyscallHelperFunctions.generated
  SyscallnameArch.generated
  SyscallRecordCase.generated
)

foreach(generated_file ${GENERATED_FILES})
  set_source_files_properties(${generated_file}
                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
  add_custom_command(OUTPUT ${generated_file}
                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
endforeach(generated_file)

add_custom_target(Generated DEPENDS ${GENERATED_FILES})

add_custom_command(OUTPUT rr_page_64
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT rr_page_32
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT rr_page_64_replay
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT rr_page_32_replay
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")

add_custom_target(Pages DEPENDS rr_page_32 rr_page_64 rr_page_32_replay rr_page_64_replay)

add_executable(rr
  src/test/cpuid_loop.S
  src/AddressSpace.cc
  src/AutoRemoteSyscalls.cc
  src/Command.cc
  src/CompressedReader.cc
  src/CompressedWriter.cc
  src/CPUIDBugDetector.cc
  src/DiversionSession.cc
  src/DumpCommand.cc
  src/EmuFs.cc
  src/Event.cc
  src/ExtraRegisters.cc
  src/fast_forward.cc
  src/FdTable.cc
  src/Flags.cc
  src/GdbCommand.cc
  src/GdbCommandHandler.cc
  src/GdbConnection.cc
  src/GdbExpression.cc
  src/GdbInitCommand.cc
  src/GdbServer.cc
  src/HelpCommand.cc
  src/kernel_abi.cc
  src/kernel_metadata.cc
  src/log.cc
  src/MagicSaveDataMonitor.cc
  src/main.cc
  src/Monkeypatcher.cc
  src/PerfCounters.cc
  src/PsCommand.cc
  src/RecordCommand.cc
  src/RecordSession.cc
  src/record_signal.cc
  src/record_syscall.cc
  src/Registers.cc
  src/remote_code_ptr.cc
  src/ReplayCommand.cc
  src/ReplaySession.cc
  src/replay_syscall.cc
  src/ReplayTimeline.cc
  src/Scheduler.cc
  src/SeccompFilterRewriter.cc
  src/Session.cc
  src/StdioMonitor.cc
  src/task.cc
  src/TraceFrame.cc
  src/TraceStream.cc
  src/util.cc
)
add_dependencies(rr Generated Pages)

target_link_libraries(rr
  -ldl
  -lrt
  ${ZLIB_LDFLAGS}
)

target_link_libraries(rrpreload
  -ldl
)

add_executable(exec_stub src/exec_stub.c)
set_target_properties(exec_stub PROPERTIES LINK_FLAGS -nostdlib)
set_source_files_properties(src/exec_stub.c
                            COMPILE_FLAGS "-fno-stack-protector")

install(PROGRAMS scripts/signal-rr-recording.sh
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay
  DESTINATION bin)

install(TARGETS rr rrpreload exec_stub
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

# Build 32-bit librrpreload on 64-bit builds.
# We copy the source files into '32' subdirectories in the output
# directory, so we can set different compile options on them.
# This sucks but I can't find a better way to get CMake to build
# the same source file in two different ways.
if(rr_64BIT)
  foreach(file preload_interface.h)
    set_source_files_properties(32/${file}
                                PROPERTIES GENERATED true HEADER_FILE_ONLY true)
    add_custom_command(OUTPUT 32/${file}
                       COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
                               cp "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                                  "${CMAKE_CURRENT_BINARY_DIR}/32/${file}"
	               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}")
  endforeach(file)

  foreach(file preload.c raw_syscall.S syscall_hook.S breakpoint_table.S)
    set_source_files_properties(32/${file}
                                PROPERTIES GENERATED true COMPILE_FLAGS "-m32 -O2")
    add_custom_command(OUTPUT 32/${file}
                       COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
                               cp "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                                  "${CMAKE_CURRENT_BINARY_DIR}/32/${file}"
	               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/preload/${file}"
                               32/preload_interface.h)
  endforeach(file)

  add_library(rrpreload_32
    32/preload.c
    32/raw_syscall.S
    32/syscall_hook.S
    32/breakpoint_table.S
  )
  set_target_properties(rrpreload_32 PROPERTIES LINK_FLAGS -m32)
  target_link_libraries(rrpreload_32
    -ldl
  )

  foreach(file exec_stub.c)
    set_source_files_properties(32/${file}
                                PROPERTIES GENERATED true COMPILE_FLAGS "-m32 -fno-stack-protector")
    add_custom_command(OUTPUT 32/${file}
                       COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
                               cp "${CMAKE_CURRENT_SOURCE_DIR}/src/${file}"
                                  "${CMAKE_CURRENT_BINARY_DIR}/32/${file}")
  endforeach(file)

  add_executable(exec_stub_32 32/exec_stub.c)
  set_target_properties(exec_stub_32 PROPERTIES LINK_FLAGS "-nostdlib -m32")

  install(TARGETS rrpreload_32 exec_stub_32
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)
endif()

##--------------------------------------------------
## Testing

# A "basic test" consists of a foo.c source file. All basic tests use the
# same basic_test.run driver script. The test name is passed as an additional
# parameter to the driver script. This script just does
# "compare_test EXIT-SUCCESS", i.e. records and replays the program and verifies
# that the output of both runs is identical and contains EXIT-SUCCESS.
#
# NB: you must update this variable when adding a new test source
# file.  The list is not generated automatically.
#
# Alphabetical, please.
set(BASIC_TESTS
  64bit_child
  _llseek
  accept
  alarm
  alarm2
  alsa_ioctl
  arch_prctl
  async_segv_ignored
  async_signal_syscalls2
  at_threadexit
  bad_ip
  bad_syscall
  barrier
  big_buffers
  block
  blocked_sigsegv
  brk
  brk2
  capget
  chew_cpu
  chown
  clock
  clone
  clone_bad_stack
  clone_immediate_exit
  clone_untraced
  constructor
  creat_address_not_truncated
  desched_blocking_poll
  dup
  epoll_create
  epoll_create1
  exec_flags
  exec_self
  fadvise
  fault_in_code_page
  fcntl_owner_ex
  fcntl_dupfd
  fcntl_seals
  fcntl_sig
  fd_tracking_across_threads
  fds_clean
  flock
  flock2
  fork_brk
  fork_child_crash
  fork_stress
  fxregs
  getgroups

=== debian/changelog ===
rr (4.1.0-2) unstable; urgency=medium

  * Add missing build-dependency on gdb (with thanks to the ever-
    vigilant Chris Lamb; closes: #814211).

 -- Stephen Kitt <skitt@debian.org>  Tue, 09 Feb 2016 10:45:20 +0100

rr (4.1.0-1) unstable; urgency=medium

  * New upstream release (now supporting Skylake CPUs).
  * Switch to https: VCS URIs (see #810378).

 -- Stephen Kitt <skitt@debian.org>  Mon, 08 Feb 2016 23:39:35 +0100

rr (4.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 23 Nov 2015 08:38:45 +0100

rr (4.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 11 Nov 2015 12:09:26 +0100

rr (4.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the rr manpage.
  * Update README.Debian (closes: #803231).

 -- Stephen Kitt <skitt@debian.org>  Mon, 02 Nov 2015 14:00:47 +0100

rr (4.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Install the supporting binaries to /usr/lib/rr instead of /usr/bin.
  * Update rr manpage and add one for signal-rr-recording.

 -- Stephen Kitt <skitt@debian.org>  Wed, 28 Oct 2015 00:12:49 +0100

=== debian/control ===
Source: rr
Section: devel
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Build-Depends:
 autotools-dev,
 cmake,
 debhelper (>= 9),
 g++-multilib,
 gdb,
 libdisasm-dev,
 libpfm4-dev,
 pkg-config,
 python,
 python-pexpect,
 zlib1g-dev,
# The following are required for the test suite
# realpath
Standards-Version: 3.9.6
Homepage: http://rr-project.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git

Package: rr
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge, Haswell, Broadwell
 and Skylake CPUs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS += -O-Bbuild

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel Merom, Nehalem, Sandy Bridge and Ivy Bridge)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
	mv debian/rr/usr/bin/exec_stub* debian/rr/usr/lib/rr/
	mv debian/rr/usr/bin/rr_page_* debian/rr/usr/lib/rr/

%:
	dh $@ --with autotools-dev --buildsystem=cmake

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/rr-$1.tar.gz/,dversionmangle=s/\+dfsg$//" \
 https://github.com/mozilla/rr/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## rr 4.3.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 2.8.5)
project(rr C CXX ASM)

# On single configuration generators, make Debug the default configuration
if(NOT CMAKE_CONFIGURATION_TYPES)
  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Whether to build in `Debug` or `Release` mode." FORCE)
  endif()
endif()

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

set(WILL_RUN_TESTS ON CACHE BOOL "Run tests")

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 4)
set(rr_VERSION_MINOR 3)
set(rr_VERSION_PATCH 0)

add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes")
set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror")
set(CMAKE_C_FLAGS_RELEASE "-O2")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -g3 -Wall -Wextra")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror")
set(CMAKE_CXX_FLAGS_RELEASE "-O2")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
endif()

option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")

if(force32bit)
  set(rr_32BIT true)
  set(rr_64BIT false)
  set(rr_MBITNESS_OPTION -m32)
else()
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(disable32bit)
      set(rr_32BIT false)
    else()
      set(rr_32BIT true)
    endif()
    set(rr_64BIT true)
  else()
    set(rr_32BIT true)
    set(rr_64BIT false)
  endif()
  set(rr_MBITNESS_OPTION)
endif()


# Check that compiling 32-bit code on a 64-bit target works, if required.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND rr_32BIT)
  # try_compile won't accept LINK_FLAGS, so do this manually.
  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
  execute_process(COMMAND ${CMAKE_C_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
			RESULT_VARIABLE COMPILER_32BIT_RESULT)
  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation. Install the required packages or pass -Ddisable32bit=ON to cmake.")
  endif()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")

find_package(PkgConfig REQUIRED)

# If we're cross-compiling a 32-bit rr build on a 64-bit host we need
# to ensure we're looking for the right libraries.
# This has been tested on Ubuntu and Fedora.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND NOT rr_64BIT)
  set(LIBDIR32_CANDIDATES
    /usr/lib/i386-linux-gnu/pkgconfig/
    /usr/lib/pkgconfig/
  )
  foreach(libdir ${LIBDIR32_CANDIDATES})
    if(IS_DIRECTORY ${libdir})
      set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
      break()
     endif()
   endforeach(libdir)
   if(NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
     message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
   endif()
endif()

# Check for required libraries
set(REQUIRED_LIBS
  zlib
)
foreach(required_lib ${REQUIRED_LIBS})
  string(TOUPPER ${required_lib} PKG)
  pkg_check_modules(${PKG} REQUIRED ${required_lib})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
endforeach(required_lib)

# Check for Python >=2.7 but not Python 3.
find_package(PythonInterp 2.7 REQUIRED)
if(PYTHON_VERSION_MAJOR GREATER 2)
  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
endif()

execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "# nothing"
                RESULT_VARIABLE python_status)
if(python_status)
  message(FATAL_ERROR "Couldn't run python interpreter ${PYTHON_EXECUTABLE}.")
endif()

# Check for required Python modules
if(WILL_RUN_TESTS)
  set(REQUIRED_PYTHON_MODULES
    pexpect
  )
else()
  set(REQUIRED_PYTHON_MODULES)
endif()

foreach(py_module ${REQUIRED_PYTHON_MODULES})
  execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
			"import ${py_module}"
			RESULT_VARIABLE module_status)
  if(module_status)
    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
  endif()
endforeach(py_module)

if(WILL_RUN_TESTS)
  # Check for gdb
  execute_process(COMMAND "gdb" "--version" RESULT_VARIABLE module_status OUTPUT_QUIET)
  if(module_status)
    message(FATAL_ERROR "Couldn't find gdb.")
  endif()
endif()

set_source_files_properties(src/preload/preload.c
                            PROPERTIES COMPILE_FLAGS ${CMAKE_C_FLAGS_RELEASE})

include_directories("${PROJECT_SOURCE_DIR}/include")
# We need to know where our generated files are.
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

add_library(rrpreload
  src/preload/preload.c
  src/preload/raw_syscall.S
  src/preload/syscall_hook.S
  src/preload/breakpoint_table.S
)

# Ensure that CMake knows about our generated files.
#
# Alphabetical, please.
set(GENERATED_FILES
  AssemblyTemplates.generated
  CheckSyscallNumbers.generated
  SyscallEnumsX64.generated
  SyscallEnumsX86.generated
  SyscallEnumsForTestsX64.generated
  SyscallEnumsForTestsX86.generated
  SyscallHelperFunctions.generated
  SyscallnameArch.generated
  SyscallRecordCase.generated
)

foreach(generated_file ${GENERATED_FILES})
  set_source_files_properties(${generated_file}
                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
  add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
endforeach(generated_file)

add_custom_target(Generated DEPENDS ${GENERATED_FILES})

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32"
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay"
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay"
                   COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py"
                   "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_rr_page.py")

add_custom_target(Pages DEPENDS
                  "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32"
                  "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"
                  "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay"
                  "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay")

set(RR_SOURCES
  src/test/cpuid_loop.S
  src/AddressSpace.cc
  src/AutoRemoteSyscalls.cc
  src/Command.cc
  src/CompressedReader.cc
  src/CompressedWriter.cc
  src/CPUIDBugDetector.cc
  src/DiversionSession.cc
  src/DumpCommand.cc
  src/ElfReader.cc
  src/EmuFs.cc
  src/Event.cc
  src/ExtraRegisters.cc
  src/fast_forward.cc
  src/FdTable.cc
  src/Flags.cc
  src/ftrace.cc
  src/GdbCommand.cc
  src/GdbCommandHandler.cc
  src/GdbConnection.cc
  src/GdbExpression.cc
  src/GdbInitCommand.cc
  src/GdbServer.cc
  src/HasTaskSet.cc
  src/HelpCommand.cc
  src/kernel_abi.cc
  src/kernel_metadata.cc
  src/log.cc
  src/MagicSaveDataMonitor.cc
  src/MonitoredSharedMemory.cc
  src/Monkeypatcher.cc
  src/PerfCounters.cc
  src/ProcMemMonitor.cc
  src/PsCommand.cc
  src/RecordCommand.cc
  src/RecordSession.cc
  src/record_signal.cc
  src/record_syscall.cc
  src/RecordTask.cc
  src/Registers.cc
  src/remote_code_ptr.cc
  src/ReplayCommand.cc
  src/ReplaySession.cc
  src/replay_syscall.cc
  src/ReplayTask.cc
  src/ReplayTimeline.cc
  src/ReturnAddressList.cc
  src/Scheduler.cc
  src/SeccompFilterRewriter.cc
  src/Session.cc
  src/StdioMonitor.cc
  src/Task.cc
  src/TaskGroup.cc
  src/TraceFrame.cc
  src/TraceStream.cc
  src/VirtualPerfCounterMonitor.cc
  src/util.cc
  src/WaitStatus.cc)

function(post_build_executable target)
# grsecurity needs these. But if we add them ourselves, they may conflict
# with other flags added in other ways, and they all have to match :-(. So
# don't do this until a better solution presents itself
#  add_custom_command(TARGET ${target}
#                     POST_BUILD
#                     COMMAND setfattr ARGS -n user.pax.flags -v m $<TARGET_FILE:${target}>)
endfunction(post_build_executable)

option(RR_BUILD_SHARED "Build the rr shared library as well as the binary (experimental).")
if(RR_BUILD_SHARED)
  add_library(rr ${RR_SOURCES})
  add_executable(rrbin src/main.cc)
  set(RR_BIN rrbin)
  post_build_executable(rrbin)
  set_target_properties(rrbin PROPERTIES OUTPUT_NAME rr)
  target_link_libraries(rrbin rr)
else()
  add_executable(rr ${RR_SOURCES} src/main.cc)
  post_build_executable(rr)
  set(RR_BIN)
endif()
add_dependencies(rr Generated Pages)

target_link_libraries(rr
  ${CMAKE_DL_LIBS}
  -lrt
  ${ZLIB_LDFLAGS}
)

target_link_libraries(rrpreload
  ${CMAKE_DL_LIBS}
)

add_executable(rr_exec_stub src/exec_stub.c)
post_build_executable(rr_exec_stub)
set_target_properties(rr_exec_stub PROPERTIES LINK_FLAGS -nostdlib)
set_source_files_properties(src/exec_stub.c
                            COMPILE_FLAGS "-fno-stack-protector")

set(RR_GDB_RESOURCES
  32bit-avx.xml
  32bit-core.xml
  32bit-linux.xml
  32bit-sse.xml
  64bit-avx.xml
  64bit-core.xml
  64bit-linux.xml
  64bit-sse.xml
  amd64-avx-linux.xml
  amd64-linux.xml
  i386-avx-linux.xml
  i386-linux.xml
)
foreach(file ${RR_GDB_RESOURCES})
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/third-party/gdb/${file}"
                 "${CMAKE_CURRENT_BINARY_DIR}/share/rr/${file}"
                 COPYONLY)
  install(FILES third-party/gdb/${file}
          DESTINATION share/rr)
endforeach(file)

install(PROGRAMS scripts/signal-rr-recording.sh
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32
                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay
  DESTINATION bin)

install(TARGETS rr ${RR_BIN} rrpreload rr_exec_stub
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

# Build 32-bit librrpreload on 64-bit builds.

=== debian/changelog ===
rr (4.3.0-1) unstable; urgency=medium

  * New upstream release:
    - drop scheduler-math.h.patch, merged upstream;
    - refresh move-librrpreload.patch and move-page-exec-stub.patch
      (upstream installs its binaries stubs in /usr/bin now, prefixed with
      rr_; this package installs them in /usr/lib/rr instead).

 -- Stephen Kitt <skitt@debian.org>  Thu, 30 Jun 2016 20:09:45 +0200

rr (4.2.0-2) unstable; urgency=medium

  * Include math.h in Scheduler.cc (closes: #822496).
  * Standards-Version 3.9.8, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 25 Apr 2016 21:06:50 +0200

rr (4.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 3.9.7, no change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 Mar 2016 21:07:51 +0100

=== debian/control ===
Source: rr
Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: autotools-dev,
               cmake,
               debhelper (>= 9),
               g++-multilib,
               gdb,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python,
               python-pexpect,
               zlib1g-dev
# The following are required for the test suite
# realpath
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
Homepage: http://rr-project.org

Package: rr
Architecture: amd64 i386
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge, Haswell, Broadwell
 and Skylake CPUs.

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 override_dh_auto_install:
 	dh_auto_install
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
-	mv debian/rr/usr/bin/exec_stub* debian/rr/usr/lib/rr/
-	mv debian/rr/usr/bin/rr_page_* debian/rr/usr/lib/rr/
+	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
 %:
 	dh $@ --with autotools-dev --buildsystem=cmake

## rr 4.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,18 +22,18 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 4)
-set(rr_VERSION_MINOR 3)
+set(rr_VERSION_MINOR 4)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes")
-set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror")
+set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -g3 -Wall -Wextra")
-set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror")
+set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
 
@@ -150,10 +150,17 @@
   endif()
 endif()
 
+set(PRELOAD_COMPILE_FLAGS "-fno-stack-protector")
+
+if (NOT DEBUG_PRELOAD_LIB)
+set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
+endif()
+
 set_source_files_properties(src/preload/preload.c
-                            PROPERTIES COMPILE_FLAGS ${CMAKE_C_FLAGS_RELEASE})
+                            PROPERTIES COMPILE_FLAGS ${PRELOAD_COMPILE_FLAGS})
 
 include_directories("${PROJECT_SOURCE_DIR}/include")
+include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
 # We need to know where our generated files are.
 include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 
@@ -245,9 +252,11 @@
   src/kernel_metadata.cc
   src/log.cc
   src/MagicSaveDataMonitor.cc
+  src/MmappedFileMonitor.cc
   src/MonitoredSharedMemory.cc
   src/Monkeypatcher.cc
   src/PerfCounters.cc
+  src/ProcFdDirMonitor.cc
   src/ProcMemMonitor.cc
   src/PsCommand.cc
   src/RecordCommand.cc
@@ -269,6 +278,7 @@
   src/StdioMonitor.cc
   src/Task.cc
   src/TaskGroup.cc
+  src/ThreadDb.cc
   src/TraceFrame.cc
   src/TraceStream.cc
   src/VirtualPerfCounterMonitor.cc
@@ -311,7 +321,8 @@
 
 add_executable(rr_exec_stub src/exec_stub.c)
 post_build_executable(rr_exec_stub)
-set_target_properties(rr_exec_stub PROPERTIES LINK_FLAGS -nostdlib)
+set_target_properties(rr_exec_stub
+                      PROPERTIES LINK_FLAGS "-nostartfiles -nodefaultlibs")
 set_source_files_properties(src/exec_stub.c
                             COMPILE_FLAGS "-fno-stack-protector")
 
@@ -340,13 +351,3 @@
 install(PROGRAMS scripts/signal-rr-recording.sh
                   ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
                   ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay
-  DESTINATION bin)
-
-install(TARGETS rr ${RR_BIN} rrpreload rr_exec_stub
-  RUNTIME DESTINATION bin
-  LIBRARY DESTINATION lib
-  ARCHIVE DESTINATION lib)
-
-# Build 32-bit librrpreload on 64-bit builds.

=== debian/changelog ===
rr (4.4.0-2) unstable; urgency=medium

  * Disable PIE (closes: #844871).
  * Switch to debhelper compatibility level 10.

 -- Stephen Kitt <skitt@debian.org>  Mon, 28 Nov 2016 23:10:02 +0100

rr (4.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Oct 2016 15:47:05 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,8 @@
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: autotools-dev,
-               cmake,
-               debhelper (>= 9),
+Build-Depends: cmake,
+               debhelper (>= 10),
                g++-multilib,
                gdb,
                libdisasm-dev,

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# rr doesn't build with PIE
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 
 export DH_OPTIONS += -O-Bbuild
 
@@ -16,4 +19,4 @@
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
 %:
-	dh $@ --with autotools-dev --buildsystem=cmake
+	dh $@ --buildsystem=cmake

## rr 4.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,31 +14,34 @@
 set(BUILD_SHARED_LIBS ON)
 
 set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
-set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
-
-set(WILL_RUN_TESTS ON CACHE BOOL "Run tests")
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/rr)
+
+set(BUILD_TESTS ON CACHE BOOL "Build tests")
+set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 4)
-set(rr_VERSION_MINOR 4)
+set(rr_VERSION_MINOR 5)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes -std=gnu11")
 set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -g3 -Wall -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11 -pthread -g3 -Wall -Wextra")
 set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
 
+if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
+endif()
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 endif()
 
@@ -112,6 +115,11 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
 endforeach(required_lib)
 
+find_path(SECCOMP NAMES "linux/seccomp.h")
+if(NOT SECCOMP)
+  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
+endif()
+
 # Check for Python >=2.7 but not Python 3.
 find_package(PythonInterp 2.7 REQUIRED)
 if(PYTHON_VERSION_MAJOR GREATER 2)
@@ -126,6 +134,10 @@
 
 # Check for required Python modules
 if(WILL_RUN_TESTS)
+  if(NOT BUILD_TESTS)
+    message(FATAL_ERROR "Running tests requires building them")
+  endif()
+
   set(REQUIRED_PYTHON_MODULES
     pexpect
   )
@@ -238,6 +250,7 @@
   src/ExtraRegisters.cc
   src/fast_forward.cc
   src/FdTable.cc
+  src/FileMonitor.cc
   src/Flags.cc
   src/ftrace.cc
   src/GdbCommand.cc
@@ -271,6 +284,7 @@
   src/replay_syscall.cc
   src/ReplayTask.cc
   src/ReplayTimeline.cc
+  src/RerunCommand.cc
   src/ReturnAddressList.cc
   src/Scheduler.cc
   src/SeccompFilterRewriter.cc
@@ -297,15 +311,20 @@
 option(RR_BUILD_SHARED "Build the rr shared library as well as the binary (experimental).")
 if(RR_BUILD_SHARED)
   add_library(rr ${RR_SOURCES})
+  set_target_properties(rr PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
   add_executable(rrbin src/main.cc)
   set(RR_BIN rrbin)
   post_build_executable(rrbin)
   set_target_properties(rrbin PROPERTIES OUTPUT_NAME rr)
   target_link_libraries(rrbin rr)
+  install(TARGETS rr
+    RUNTIME DESTINATION bin
+    LIBRARY DESTINATION lib
+    ARCHIVE DESTINATION lib)
 else()
   add_executable(rr ${RR_SOURCES} src/main.cc)
   post_build_executable(rr)
-  set(RR_BIN)
+  set(RR_BIN rr)
 endif()
 add_dependencies(rr Generated Pages)
 
@@ -322,7 +341,7 @@
 add_executable(rr_exec_stub src/exec_stub.c)
 post_build_executable(rr_exec_stub)
 set_target_properties(rr_exec_stub
-                      PROPERTIES LINK_FLAGS "-nostartfiles -nodefaultlibs")
+                      PROPERTIES LINK_FLAGS "-static -nostartfiles -nodefaultlibs")
 set_source_files_properties(src/exec_stub.c
                             COMPILE_FLAGS "-fno-stack-protector")
 
@@ -330,24 +349,3 @@
   32bit-avx.xml
   32bit-core.xml
   32bit-linux.xml
-  32bit-sse.xml
-  64bit-avx.xml
-  64bit-core.xml
-  64bit-linux.xml
-  64bit-sse.xml
-  amd64-avx-linux.xml
-  amd64-linux.xml
-  i386-avx-linux.xml
-  i386-linux.xml
-)
-foreach(file ${RR_GDB_RESOURCES})
-  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/third-party/gdb/${file}"
-                 "${CMAKE_CURRENT_BINARY_DIR}/share/rr/${file}"
-                 COPYONLY)
-  install(FILES third-party/gdb/${file}
-          DESTINATION share/rr)
-endforeach(file)
-
-install(PROGRAMS scripts/signal-rr-recording.sh
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay

=== debian/changelog ===
rr (4.5.0-1) unstable; urgency=medium

  * New upstream release, merging move-librrpreload.patch.
  * Update watch file.
  * Import upstream fix to build with GCC 7 (closes: #853646).
  * Standards-Version 4.0.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 24 Jun 2017 23:10:55 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                zlib1g-dev
 # The following are required for the test suite
 # realpath
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
 Homepage: http://rr-project.org
